<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<con:xqueryEntry xmlns:con="http://www.bea.com/wli/sb/resources/config">
  <con:xquery>xquery version "1.0" encoding "UTF-8";
(:: pragma bea:local-element-complex-parameter parameter="$request1" type="ns0:GenericParallelRequestType/ns0:Requests/ns0:Request" location="../GenericParallelService.wsdl" ::)
(:: pragma  type="xs:anyType" ::)
 
(: (C) Vladimir Dyuzhev http://genericparallel.com GenericParallel is a simpler and a more functional wrapper over Split &amp; Join facility. :)
 
declare namespace xf = "http://tempuri.org/GenericParallel/Utility/ExtractUserHeaders/";
declare namespace ns0 = "http://genericparallel/types";
 
declare function xf:ExtractUserHeaders($request1 as element()) as element(*) {
                                &lt;UserHeaders&gt;
        {
                for $h in $request1/ns0:GPSPassHeaders/*
                return
                if( $h/@name = ('GPSTarget', 'GPSTargetType',  'GPSTargetIsProxy', 'GPSOperation', 'GPSPassHeaders') ) then ()
                else &lt;UserHeader Name="{data($h/@name)}" Value="{data($h/@value)}"/&gt;
        }
        {
                for $attr in $request1/@*
                let $ln := local-name($attr)
                return
                if( $ln = ('GPSTarget', 'GPSTargetType', 'GPSTargetIsProxy', 'GPSOperation', 'GPSPassHeaders') ) then ()
                else &lt;UserHeader Name="{$ln}" Value="{data($attr)}"/&gt;
        }
        &lt;/UserHeaders&gt;
};
 
declare variable $request1 as element() external;
 
xf:ExtractUserHeaders($request1)
</con:xquery>
</con:xqueryEntry>
